close all;
%clear;

%luetaan datatiedosto (tab-eroteltu tekstitiedosto, jossa mukana pelkt heat-kokeeseen 
%liittyvt data-vektorit)
heat_data = dlmread('d:\koulu\bioinformatiikka\data\heat.txt','\t');
heat_data_norm = som_normalize(heat_data,'var');

% suodatetaan pois sellaiset vektorit, joiden varianssi on pieni
for (i=1:length(heat_data(:,1)))
   var(i) =  cov(heat_data(i,:));
end

temp = find(var > 0.01);
for (i=1:length(temp))
   filtered_heat(i,:) = heat_data(temp(i),:);
end
heat_removed = find(var <= 0.01);
dlmwrite('d:\koulu\bioinformatiikka\data\heat_removed.txt',heat_removed', '\t');

%mritelln kartan koko
x = 5;
y = 5;

% opetetaan SOM
heat_norm = som_normalize(filtered_heat, 'var');
heat_som = som_make(heat_norm, 'msize', [x,y]);
figure(1);
som_show(heat_som);
figure(2);

% plotataan jokaiseen kartta-alkioon kuvautuvien geenien keskiarvoprofiili
for (i=1:x*y)
  subplot(x,y,i); 
  [V,I] = som_divide(heat_som, heat_norm,[i],'index');
  plot(mean(V));
end

% plotataan kaikki tiettyy kartta-alkioon kuvautuneet geenit
figure(3);
for (i=1:x*y)
  subplot(x,y,i); 
  [V,I] = som_divide(heat_som, heat_norm,[i],'index');
  for (j=1:length(I))
     plot(V(j,:));
     hold on;
  end
  hold off;
end

% Jaetaan data 12 klusteriin ja plotataan klusterien keskiarvoprofiilit
[centroids,clusters,err] = kmeans('batch', heat_som, 12);
figure(4);
for (i=1:12)
   subplot(4,3,i);
   plot(centroids(i,:));
end

